Index: orxonox/trunk/src/orxonox.cc
===================================================================
--- orxonox/trunk/src/orxonox.cc	(revision 3662)
+++ orxonox/trunk/src/orxonox.cc	(revision 3668)
@@ -367,14 +367,15 @@
   dt = end - ini;
 
-  int type = -1; 
+  int type = 3; 
   /* type   -1 == all 
      type    0 == framework
      type    1 == vector
      type    2 == quaternion
+     type    3 == lists
   */
   if(type == 0 || type == -1)
     {
       /* framework test*/
-
+      
       printf("Generating Objects:\t\t\t\t\t%i\n", ITERATIONS);
       /* ************WorldEntity class test************** */
@@ -510,10 +511,11 @@
 	  rdtscl(end);
 	  mittel += (end - ini - dt);
-	  }
+	}
       mi = mittel / (float)ITERATIONS;
       printf(" Call function tick() of Prim:\t\t%11.2f\n", mi);
-
-
-      }
+      
+      
+    }
+  
   if(type == 1 || type == -1)
     {
@@ -556,171 +558,172 @@
       printf(" CrossMult of two vectors:\t\t%11.2f\n", mi);
 
-      if(type == 1 || type == -1)
-	{
-	  /* quaternion test */
-	  printf("\nDoing some simple quaternion operations: \t\t%i\n", VECTOR_MAX);
-	  /* vector test */
-	  Quaternion* a = new Quaternion();
-	  Quaternion* b = new Quaternion();
-	  Quaternion* c = new Quaternion();
-	  
-	  unsigned long mittel, ini, end;
-	  float mi;
-	  int i = 0;
-	  // quaternion generieren mit spez konstruktor
-	  mittel = 0;
-	  Vector* qa = new Vector(4.6, 9.3, 0.4);
-	  Vector* qb = new Vector(3.5, 6.1, 4.3);
-	  for(i = 0; i < VECTOR_MAX; ++i)
-	    {
-	      rdtscl(ini);
-	      
-	      Quaternion* qu = new Quaternion(*qa, *qb);
-	      
-	      rdtscl(end);
-	      delete qu;
-	      mittel += (end - ini - dt);
-	    }
-	  delete a;
-	  delete b;
-	  mi = mittel / (float)VECTOR_MAX;
-	  printf(" Gen. quatern. betw. two vectors:\t%11.2f\n", mi);
-
-
-	  // multiplication
-	  mittel = 0;
-	  for(i = 0; i < VECTOR_MAX; ++i)
-	    {
-	      rdtscl(ini);
-	      
-	      *c = *a * *b;
-	      
-	      rdtscl(end);
-	      mittel += (end - ini - dt);
-	    }
-	  mi = mittel / (float)VECTOR_MAX;
-	  printf(" Multiplying two quat.(=rot): a * b\t%11.2f\n", mi);
-	  
-
-
-	  // rotating a vector by a quaternion
-	  mittel = 0;
-	  for(i = 0; i < VECTOR_MAX; ++i)
-	    {
-	      rdtscl(ini);
-	      
-	      *qa = a->apply(*qb);
-	      
-	      rdtscl(end);
-	      mittel += (end - ini - dt);
-	    }
-	  mi = mittel / (float)VECTOR_MAX;
-	  printf(" Rot a vec by a quat: q->apply(v)\t%11.2f\n", mi);
-	  
-	  
-
-	  // generate rotation matrix
-	  mittel = 0;
-	  float matrix[4][4];
-	  for(i = 0; i < VECTOR_MAX; ++i)
-	    {
-	      rdtscl(ini);
-	      
-	      a->matrix(matrix);
-	      
-	      rdtscl(end);
-	      mittel += (end - ini - dt);
-	    }
-	  mi = mittel / (float)VECTOR_MAX;
-	  printf(" Generate rot matrix: q->matrix(m)\t%11.2f\n", mi);
-	}
-      if( type == 3 || type == -1)
-	{
-	  /* list tests*/
-	  printf("\nList operations tests: \t\t\t\t\t%i\n", LIST_MAX);
-	  tList<char>* list = new tList<char>();
-	  char* name;
-
-	  printf(" Adding[1..10] elements to list, found:\n");
-	  list->add("1");
-	  list->add("2");
-	  list->add("3");
-	  list->add("4");
-	  list->add("5");
-	  list->add("6");
-	  list->add("7");
-	  list->add("8");
-	  list->add("9");
-	  list->add("10");
-
-	  /*give list out */
-	  tIterator<char>* iterator = list->getIterator();
+    }
+  if( type == 2 || type == -1)
+    {
+      /* quaternion test */
+      printf("\nDoing some simple quaternion operations: \t\t%i\n", VECTOR_MAX);
+      /* vector test */
+      Quaternion* a = new Quaternion();
+      Quaternion* b = new Quaternion();
+      Quaternion* c = new Quaternion();
+      
+      unsigned long mittel, ini, end;
+      float mi;
+      int i = 0;
+      // quaternion generieren mit spez konstruktor
+      mittel = 0;
+      Vector* qa = new Vector(4.6, 9.3, 0.4);
+      Vector* qb = new Vector(3.5, 6.1, 4.3);
+      for(i = 0; i < VECTOR_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  Quaternion* qu = new Quaternion(*qa, *qb);
+	  
+	  rdtscl(end);
+	  delete qu;
+	  mittel += (end - ini - dt);
+	}
+      delete a;
+      delete b;
+      mi = mittel / (float)VECTOR_MAX;
+      printf(" Gen. quatern. betw. two vectors:\t%11.2f\n", mi);
+      
+      
+      // multiplication
+      mittel = 0;
+      for(i = 0; i < VECTOR_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  *c = *a * *b;
+	  
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)VECTOR_MAX;
+      printf(" Multiplying two quat.(=rot): a * b\t%11.2f\n", mi);
+      
+      
+      
+      // rotating a vector by a quaternion
+      mittel = 0;
+      for(i = 0; i < VECTOR_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  *qa = a->apply(*qb);
+	  
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)VECTOR_MAX;
+      printf(" Rot a vec by a quat: q->apply(v)\t%11.2f\n", mi);
+      
+      
+      
+      // generate rotation matrix
+      mittel = 0;
+      float matrix[4][4];
+      for(i = 0; i < VECTOR_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  a->matrix(matrix);
+	  
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)VECTOR_MAX;
+      printf(" Generate rot matrix: q->matrix(m)\t%11.2f\n", mi);
+    }
+  if( type == 3 || type == -1)
+    {
+      /* list tests*/
+      printf("\nList operations tests: \t\t\t\t\t%i\n", LIST_MAX);
+      tList<char>* list = new tList<char>();
+      char* name;
+      
+      printf(" Adding[1..10] elements to list, found:\n");
+      list->add("1");
+      list->add("2");
+      list->add("3");
+      list->add("4");
+      list->add("5");
+      list->add("6");
+      list->add("7");
+      list->add("8");
+      list->add("9");
+      list->add("10");
+      
+      /*give list out */
+      tIterator<char>* iterator = list->getIterator();
+      name = iterator->nextElement();
+      printf("  List Elements: \t\t");
+      while( name != NULL)
+	{
+	  printf("%s,", name);
 	  name = iterator->nextElement();
-	  printf("  List Elements: \t\t");
-	  while( name != NULL)
-	    {
-	      printf("%s,", name);
-	      name = iterator->nextElement();
-	    }
-	  delete iterator;
-	  printf("\n");
-
-
-	  /*removing some elements from the list*/
-	  printf(" Removing elements [2,3,6,8,10], adding [11] now found:\n");
-	  list->remove("2");
-	  list->remove("3");
-	  list->remove("6");
-	  list->remove("8");
-	  list->remove("10");
-	  list->add("11");
-	  /*give list out */
-	  iterator = list->getIterator();
+	}
+      delete iterator;
+      printf("\n");
+      
+      
+      /*removing some elements from the list*/
+      printf(" Removing elements [2,3,6,8,10], adding [11] now found:\n");
+      list->remove("2");
+      list->remove("3");
+      list->remove("6");
+      list->remove("8");
+      list->remove("10");
+      list->add("11");
+      /*give list out */
+      iterator = list->getIterator();
+      name = iterator->nextElement();
+      printf("  List Elements: \t\t");
+      while( name != NULL)
+	{
+	  printf("%s,", name);
 	  name = iterator->nextElement();
-	  printf("  List Elements: \t\t");
-	  while( name != NULL)
-	    {
-	      printf("%s,", name);
-	      name = iterator->nextElement();
-	    }
-	  delete iterator;
-	  printf("\n");
-	  
-	  delete list;
-	  printf("\nChecking list performance:\t\t\t\t%i\n", LIST_MAX);
-
-	  tList<int>* plist = new tList<int>();
-	  unsigned long mittel, ini, end;
-	  float mi;
-	  int i = 0;
-	  mittel = 0;
-	  for(i = 0; i < LIST_MAX; ++i)
-	    {
-	      rdtscl(ini);
-	      
-	      plist->add(&i);
-	      
-	      rdtscl(end);
-	      mittel += (end - ini - dt);
-	    }
-	  mi = mittel / (float)LIST_MAX;
-	  printf(" Adding reference to list:\t\t%11.2f\n", mi);
-
-	  mittel = 0;
-	  for(i = 0; i < LIST_MAX; ++i)
-	    {
-	      rdtscl(ini);
-	      
-	      plist->remove(&i);
-	      
-	      rdtscl(end);
-	      mittel += (end - ini - dt);
-	    }
-	  mi = mittel / (float)LIST_MAX;
-	  printf(" Removing 1st reference from list:\t%11.2f\n", mi);
-	  
-	  
-
-	}
+	}
+      delete iterator;
+      printf("\n");
+      
+      delete list;
+      printf("\nChecking list performance:\t\t\t\t%i\n", LIST_MAX);
+      
+      tList<int>* plist = new tList<int>();
+      unsigned long mittel, ini, end;
+      float mi;
+      int i = 0;
+      mittel = 0;
+      for(i = 0; i < LIST_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  plist->add(&i);
+	  
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)LIST_MAX;
+      printf(" Adding reference to list:\t\t%11.2f\n", mi);
+      
+      mittel = 0;
+      for(i = 0; i < LIST_MAX; ++i)
+	{
+	  rdtscl(ini);
+	  
+	  plist->remove(&i);
+	  
+	  rdtscl(end);
+	  mittel += (end - ini - dt);
+	}
+      mi = mittel / (float)LIST_MAX;
+      printf(" Removing 1st reference from list:\t%11.2f\n", mi);
+      
+      
+      
     }
-}
+  
+}